package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.busi.print.method;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.ISxPrintTemplateMethodService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.ProduceSnExtModel;
import cn.estsh.i3plus.ext.mes.pcn.pojo.model.SxPrintTemplateModel;
import cn.estsh.i3plus.ext.mes.pcn.pojo.util.MesPcnExtConstWords;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description 含有特殊物料处理,商品码的条码打印数据
 * @Author: wangjie
 * @CreateDate: 2020/6/22 9:38 AM
 * @Description:
 **/
@Slf4j
@Service
public class SxPrintHasGoodsCodeAndReplacePartNoService extends SxPrintDispatchService implements ISxPrintTemplateMethodService {

    private static final String WP = "WP";
    private static final String WT = "WT";
    private static final String BN8 = " BN8";
    private static final String BW1 = " BW1";

    @Override
    public List<Map<String, Object>> exec(SxPrintTemplateModel printModel) {
        List<Map<String, Object>> resultMapList = null;
        List<ProduceSnExtModel> snList = printModel.getSnList();
        for (ProduceSnExtModel sn : snList) {
            if (null == sn) {
                continue;
            }
            if (CollectionUtils.isEmpty(resultMapList)) {
                resultMapList = new ArrayList<>();
            }
            Map<String, Object> resultMap = new HashMap<>();
            if (null != printModel.getPart()) {
                resultMap.put(MesPcnExtConstWords.PART_NO, getPartNo(printModel.getPart().getPartNo()));
                resultMap.put(MesPcnExtConstWords.GOODS_CODE, printModel.getPart().getGoodsCode());
                resultMap.put(MesPcnExtConstWords.BAR_CODE_2, printModel.getPart().getGoodsCode());
                resultMap.put(MesPcnExtConstWords.PREFIX, printModel.getPart().getPrefix());
            }
            resultMap.put(MesPcnExtConstWords.SERIAL_NUMBER, getSnWithOutPercent(sn.getSerialNumber()));
            resultMap.put(MesPcnExtConstWords.BAR_CODE, sn.getSerialNumber());
            resultMapList.add(resultMap);
        }
        return resultMapList;
    }

    private String getPartNo(String partNo) {
        if (StringUtils.isEmpty(partNo) || partNo.length() < 2) {
            return partNo;
        }
        String lastChar = partNo.substring(partNo.length() - 2).toUpperCase();
        String beforeChar = partNo.substring(0, partNo.length() - 2);
        if (lastChar.equals(WP)) {
            partNo = beforeChar + BN8;
        } else if (lastChar.equals(WT)) {
            partNo = beforeChar + BW1;
        }
        return partNo;
    }

}
